### Script: GreetWondeR
### Version: 1.4
### Finished on: Tue May 25 13:42:28 MEST 1999
### Required: Eggdrop 1.3.x
### Author:  Wingman <Wingman@Defiant.vilstal.net>
###          http://defiant.vilstal.net/~wingman/
### Please send _any_ suggestions and bugreports to:
### Wingman@Defiant.vilstal.net 
### ---
### For more informations on greetwonder.tcl, take a look at greetwonder.txt

### SETTINGS

# [dir] Where should the data of greetwonder.tcl be saved?
# Note: all files, generated by greetwonder, are stored in this directory.
set greet(dir) "./greet"

# [file] This is the file, where all user-defined variables are saved
# This file will be stored in directory $greet(dir) (e.g.: ./greet/greet.dat)
set greet(data) "greet.dat"

# [file] Where should the nick-greets be saved?
# This file will be stored in directory $greet(dir) (e.g.: ./greet/nicks.dat)
set greet(nicks) "nicks.dat"

# [lines] How many lines are allowed for greets?
# Note: .+greetfile has no line limitiation!
set greet(max) 5

# [NOTICE/PRIVMSG] How should i greet the users?
# Note: .greethow [channel] [+flag] <notice/msg>
set greet(how) "NOTICE"

# [0/1/2] Should i greet all (1), known users (0) or only unkown users (2)
# Note: .greetwho [channel] <all/known/unknown>
set greet(all) 1

# [secs] Delay time before reshowing the greets? (0 to disable)
# This means, if a users joins #chan, then greets will be reshown in
# greet(delay) seconds. Users within this time will get no greets.
set greet(delay) 15

# [0/1] Enables the simple flood protection for this tcl. This means,
# if there's a flood join, the tcl refuses the greets for n minutes
# (shutdown time is set below)
set greet(floodprotect) 1

# [mins] How long should the tcl shutdown itself after a flood attack?
set greet(noresponse) 5

### END OF SETTINGS 
### (don't change anything below, if you are not familiar with tcl)

if {![info exists numversion] || ($numversion < 1030000)} {
  if {[string range $version 0 2] != "1.3"} {
    putlog "TCL: GreetWondeR $greet(version) - Warning: This tcl was written and tested with Eggdrop 1.3.x. If an error occurs, pls send a mail to Wingman@Defiant.vilstal.net."
    }
  }

set greet(version) "1.4"

proc greet:wsg { string } {
global greet
putlog "GreetWondeR $greet(version) $string"
}

proc greet:putlog { string } {
global version
putlog $string  
}

proc stl { string } {
return [string tolower $string]
}

proc greet:lend { start string } {
set count 0
set result ""
foreach word $string {
  incr count
  if {$count > $start} {
    if {$result == ""} {
      set result $word
      } else {
      append result " $word"
      }
    }
  }
return $result
}

proc greet:load { varname } {
global greet
set file [open $greet(dir)/$greet(data) r]
while {![eof $file]} {
  set line "[gets $file]"
  set pattern [stl [lindex $line 0]]
    if {$pattern == $varname} {
      set ret "[greet:lend 2 $line]"
      close $file
      return $ret
      }
    }
close $file
return "" 
}

proc greet:save { name value } {
global greet 
set file [open $greet(dir)/$greet(data) r]
while {![eof $file]} {
  set line [gets $file]
  if {[lindex $line 0] != $name} {
    lappend datalist $line
    }
  }
close $file
set file [open $greet(dir)/$greet(data) w]
foreach line $datalist {
  if {![llength $line] < 1} {
    puts $file $line
    }
  }
puts $file "$name = $value"
close $file
return 1
}

proc greet:getchannels {} {
global chanfile
set file [open $chanfile r]
while {![eof $file]} {
  set line [gets $file]
  if {($line != "") && (![string match "#*" $line])} {
    if {![info exists channels]} {
      set channels "[lindex $line 2]"
      } else {
      append channels " [lindex $line 2]"
      }
    }
  }
close $file
return $channels
}    

proc greet:getfile { file } {
if {![file exists $file]} { return "" }
set inhalt ""
set file2read [open $file r]
while {![eof $file2read]} {
 set line "[gets $file2read]"
 if {$line != ""} {
   lappend inhalt $line
   }
 }
close $file2read
return $inhalt
}

proc greet:setxtra { handle what } {
setuser $handle XTRA wgreet $what
}

proc greet:getxtra { handle } {
set xtra [getuser $handle XTRA]
foreach string $xtra {
  if {[string match "wgreet *" $string]} {
    if {![info exists ret]} { set ret [lrange $string 1 end] } { append ret " [lrange $string 1 end]" }
    }
  }
if {![info exists ret]} { return "" }
return $ret
}

proc greet:debug { handle idx command arg } {
global greet version botnick
set file [open $greet(dir)/$greet(data) r]
while {![eof $file]} {
  lappend data [gets $file]
  }
close $file
foreach var [date] {
  append date $var
  }
set file [open greet-debug.${date} w]
  puts $file "DEBUG written on [date] at [time]"
  puts $file " "
  puts $file "Eggdrop Version: $version"
  puts $file " "
  puts $file "Command: #$handle# $command $arg"
  puts $file " "
  puts $file "$greet(data):"
  foreach line $data {
    puts $file "  $line"
    }
  puts $file " "
close $file
putdcc $idx "---"
putdcc $idx "GreetWondeR $greet(version) ERROR"
putdcc $idx " Please send the file \"greet-debug.${date}\" to Wingman@Defiant.vilstal.net."
putdcc $idx " Don't forget to put in your email adress (if u want reply)."
putdcc $idx "COMMAND CHANCELED!"
putdcc $idx "---"
}

proc greet:putinit { what idx string } {
if {$what == "start"} {
  putlog $string
  } {
  putdcc $idx $string
  }
}

proc greet:init { what idx } {
global nickgreets changreets greet
if {![file exists $greet(dir)]} {
  exec mkdir $greet(dir)
  exec mkdir $greet(dir)/channels
  foreach chan [greet:getchannels] {
    set cfilename [stl [string trimleft $chan #]]
    set file [open $greet(dir)/channels/${cfilename}.dat w]
    close $file
    if {![info exists channels_created]} { set channels_created $chan } { append channels_created ", $chan" }
    }
  set file [open $greet(dir)/$greet(data) w]
  puts $file "# TCL: GreetWondeR $greet(version)"
  puts $file "# This file was created on [date] at [time]."
  puts $file "greet(how) = $greet(how)"
  foreach chan [greet:getchannels] {
    set chan [stl $chan]
    puts $file "greet($chan) = 1"
    puts $file "greetall($chan) = $greet(all)"
    puts $file "greethow($chan) = $greet(how)"
    }
  close $file
  set file [open $greet(dir)/$greet(nicks) w]
  close $file
  greet:putinit $what $idx "-----------"
  greet:putinit $what $idx "GreetWondeR $greet(version) - Starting Setup Sequence."
  greet:putinit $what $idx " "
  greet:putinit $what $idx "  Created directory: $greet(dir)"
  if {[info exists channels_created]} { 
    greet:putinit $what $idx "  Created channelfile(s): $channels_created"
    }
  greet:putinit $what $idx "  Created datafile: $greet(data)"
  greet:putinit $what $idx "  Created nickfile: $greet(nicks)"
  if {$greet(floodprotect) == 1} {
    greet:putinit $what $idx " "
    greet:putinit $what $idx "  Flood Protection enabled."
    greet:putinit $what $idx "    Flood settings:"
    foreach chanz [channels] {
      if {![info exists cl]} {
        set cl [string length $chanz]
        } {
        set cl2 [string length $chanz]
        if {$cl2 > $cl} { set cl $cl2 }
        }
      }
     greet:putinit $what $idx "      [format "%-${cl}s   %5s   %1s" Channel Joins Secs]"
    foreach chan [channels] {
      set joins [lindex [split [lindex [channel info $chan] 9] :] 0]
      set secs [lindex [split [lindex [channel info $chan] 9] :] 1]
      if {$joins == 0 || $secs == 0} {
        if {![info exists cwofs]} { set cwofs $chan } { append cwofs ", $chan" }
	} {
        greet:putinit $what $idx "      [format "%-${cl}s   %-5s   %1s" $chanz $joins $secs]" 
	}
      }
    if {[info exists cwofs]} {
      greet:putinit $what $idx " "
      greet:putinit $what $idx "    Channels with no flood settings:"
      greet:putinit $what $idx "    $cwofs"
      greet:putinit $what $idx "  (use .chanset <chan> flood-join <joins>:<secs>)"
      }
    bind flud - join greet:flood
    }
  greet:putinit $what $idx " "
  greet:putinit $what $idx "GreetWonder $greet(version) - Setup complete."
  greet:putinit $what $idx "-----------"
  if {$idx == "-"} {
    putlog "GreetWondeR $greet(version) by Wingman (c) 1999 loaded (.greethelp for help)."
    }
  set nickgreets [greet:getfile $greet(dir)/$greet(nicks)]
  foreach chan [channels] {
    set changreets([stl $chan]) [greet:getfile $greet(dir)/channels/[stl [string trimleft $chan #]].dat]
    }
  return 0
  }
if {![file exists $greet(dir)/$greet(data)]} {
  set file [open $greet(dir)/$greet(data) w]
  puts $file "# TCL: GreetWondeR $greet(version)"
  puts $file "# This file was created on [date] at [time]."
  puts $file "greet(how) = $greet(how)"
  foreach chan [greet:getchannels] {
    set chan [stl $chan]
    puts $file "greet($chan) = 1"
    puts $file "greetall($chan) = $greet(all)"
    puts $file "greethow($chan) = $greet(how)"
    }
  close $file
  }
if {![file exists $greet(dir)/$greet(data)]} {
  set file [open $greet(dir)/$greet(data)]
  close $file
  } {
  set file [open $greet(dir)/$greet(data) r]
  set olddataver [lindex [gets $file] 3]
  close $file
  if {$greet(version) != $olddataver} {
    putlog "-----------"
    putlog "GreetWondeR $greet(version) Starting Update Sequence."
    putlog " "
    putlog "  Found old version: $olddataver."
    set file [open $greet(dir)/$greet(data) r]
    while {![eof $file]} {
      set line [gets $file]
      if {![string match "#*" $line]} {
        lappend tmp $line
	}
      }
    close $file
    set file [open $greet(dir)/$greet(data) w]
    puts $file "# TCL: GreetWondeR $greet(version)"
    puts $file "# This file was created on [date] at [time]."
    foreach line $tmp {
      if {$line != ""} { puts $file $line }
      }
    close $file
    set publicver "1.0.0 1.0.1 1.0.2 1.0.3 1.0.4 1.0.5 1.1 1.2 1.2+greet:joinfix 1.3"
    if {[lsearch -exact $publicver $olddataver] == -1} {
      putlog " "
      putlog "WARNING: Hacked old GreetWondeR Version found!"
      putlog "         Deleting all greets and restarting..."
      putlog "-----------"
      exec rm -rf $greet(dir)
      greet:init start - 
      return 0
      } {
      putlog "  Found old datafile: converted."
      if {![file exists $greet(dir)/channels]} {
        exec mkdir $greet(dir)/channels
	}
      foreach chan [greet:getchannels] {
        set ccount($chan) 0
        if {![file exists $greet(dir)/[stl [string trimleft $chan #]].dat]} {
	  if {![info exists tmp4]} { set tmp4 $chan } { append tmp4 ", $chan" }
	  } {
          set file [open $greet(dir)/[stl [string trimleft $chan #]].dat r]
	  while {![eof $file]} {
	    set line [gets $file]
            while {[string match "* (nick) *" $line] || [string match "* (nick)" $line] || [string match "(nick) *" $line]} {
              incr ccount($chan)
	      set found [lsearch -exact $line "(nick)"]
              set line [lreplace $line $found $found greet-nick]
              }
            while {[string match "* (chan) *" $line] || [string match "* (chan)" $line] || [string match "(chan) *" $line]} {
	      incr ccount($chan)
              set found [lsearch -exact $line "(chan)"]
              set line [lreplace $line $found $found greet-chan]
              }
            while {[string match "* (botnick) *" $line] || [string match "* (botnick)" $line] || [string match "(botnick) *" $line]} {
	      incr ccount($chan)
              set found [lsearch -exact $line "(botnick)"]
              set line [lreplace $line $found $found greet-botnick]
              }
	    if {$line != ""} { 
              lappend tmp2 $line
              }
	    }
          close $file
	  set file [open $greet(dir)/channels/[stl [string trimleft $chan #]].dat w]
          if {[info exists tmp2]} {
            foreach line $tmp2 {
	      puts $file $line
	      }
	    }  
	  close $file
          exec mv $greet(dir)/[stl [string trimleft $chan #]].dat $greet(dir)/channels/[stl [string trimleft $chan #]].old
	  }
	}
      putlog " " 
      if {[info exists tmp4]} {
        putlog "  Can't find old channelfile(s): $tmp4"
        }
      putlog " " 
      putlog "  Searching channelfiles for old formatings... (e.g. (nick)):"  
      foreach chan [greet:getchannels] {
        if {$ccount($chan) != 0} {
          set tmp5 1 
          putlog "    $chan: $ccount($chan) word(s) converted"
          }
        }  
      if {![info exists tmp5]} { putlog "    No old formatings found." } 
      if {![file exists $greet(dir)/$greet(nicks)]} {
        set file [open $greet(dir)/$greet(nicks) w]
	close $file
	} {
        set ncount 0
	set file [open $greet(dir)/$greet(nicks) r]
        while {![eof $file]} {
          set line [gets $file]
          while {[string match "* (nick) *" $line] || [string match "* (nick)" $line] || [string match "(nick) *" $line]} {
            incr ncount
            set found [lsearch -exact $line "(nick)"]
            set line [lreplace $line $found $found greet-nick]
            }
          while {[string match "* (chan) *" $line] || [string match "* (chan)" $line] || [string match "(chan) *" $line]} {
            incr ncount
            set found [lsearch -exact $line "(chan)"]
            set line [lreplace $line $found $found greet-chan]
            }
          while {[string match "* (botnick) *" $line] || [string match "* (botnick)" $line] || [string match "(botnick) *" $line]} {
            incr ncount
            set found [lsearch -exact $line "(botnick)"]
            set line [lreplace $line $found $found greet-botnick]
            }
          if {$line != ""} { lappend tmp4 $line }
          }
        close $file
	set file [open $greet(dir)/$greet(nicks) w]
        if {[info exists tmp4]} {
          foreach line $tmp4 {
	    if {[llength $line] < 2} { puts $file $line } 
	    }  
          }
	close $file
        putlog " "
	putlog "  Searching nickfile for old formatings... (e.g. (chan)):"
        if {$ncount != 0} {
	  putlog "    Found $ncount word(s) - converted"
	  } {
	  putlog "    No old formatings found."
	  }
	}
      putlog " "
      putlog "GreetWondeR $greet(version) - Update complete."
      putlog "-----------"
      }
    }
  }  
if {![file exists $greet(dir)/channels]} {
  exec mkdir $greet(dir)/channels
  }
if {![file exists $greet(dir)/$greet(nicks)]} {
  set file [open $greet(dir)/$greet(nicks) w]
  close $file
  }
foreach chan [greet:getchannels] {
  if {![file exists $greet(dir)/channels/[stl [string trimleft $chan #]].dat]} {
    set file [open $greet(dir)/channels/[stl [string trimleft $chan #]].dat w]
    close $file
    }
  }  
set nickgreets [greet:getfile $greet(dir)/$greet(nicks)]
foreach chan [greet:getchannels] {
  set changreets([stl $chan]) [greet:getfile $greet(dir)/channels/[stl [string trimleft $chan #]].dat]
  }
putlog "GreetWondeR $greet(version) by Wingman (c) 1999 loaded (.greethelp for help)."
}

proc greet:flood { nick uhost handle type chan } {
global greetflood
greet:wsg "WARNING: flood joins detected at $chan...shutting down $chan greets..."
timer $greet(noresponse) "greet:startup $chan"
set greetflood($chan) 1
}

proc greet:startup { chan } {
global greetflood
greet:wsg "Flood ($chan) seems to be over...restarting $chan greets..."
set greetflood($chan) 0
}

bind chon n * motd:greet
proc motd:greet { handle idx } {
global greet
set greetmotd [greet:getxtra $handle]
if {$greetmotd == 0} {
  return 0
  }
putdcc $idx " "
putdcc $idx "This Bot is using GreetWondeR $greet(version)"
putdcc $idx "You are a global owner. Try .greethelp for a list of commands."
putdcc $idx "(to deactivate this message, try .gmotd off)"
putdcc $idx " "
}

bind dcc m|n gmotd dcc:gmotd
proc dcc:gmotd { handle idx arg } {
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .gmotd <on/off>"
  return 0
  }
greet:putlog "#$handle# gmotd $arg"
set handle [stl $handle]
set arg [stl $arg]
if {$arg == "on"} {
  greet:setxtra $handle 1
  putdcc $idx "GreetWondeR MOTD turned on."
  return 0
  }
if {$arg == "off"} {
  greet:setxtra $handle 0
  putdcc $idx "GreetWondeR MOTD turned off."
  return 0
  }
putdcc $idx "Usage: .gmotd <on/off>"
}

bind dcc n greetreset dcc:greetreset	   
proc dcc:greetreset { handle idx arg } {
global greet greet_loaded
greet:putlog "#$handle# greetreset"
putdcc $idx "Resetting GreetWondeR..."
if {[file exists $greet(dir)]} {
  exec rm -rf $greet(dir)
  }
greet:init reset $idx 
putdcc $idx "Done, GreetWondeR successfully resetted."
}

bind dcc m greetstatus dcc:greetstatus
proc dcc:greetstatus { handle idx arg } {
global greet flood nickgreets version
if {[llength $arg] < 1} {
  set chan [lindex [console $idx] 0]
  if {$chan == "*"} {
    putdcc $idx "Your console channel is invalid."
    return 0
    }
  } else {
  if {![validchan $arg]} {
    putdcc $idx "I'm not on $arg."
    return 0
    }
  set chan [lindex $arg 0]
  }
if {$greet(all) == 0} { 
  set a "unkown"
  }
if {$greet(all) == 1} {
  set a "all"
  }
if {$greet(all) == 2} {
  set a "known"
  }
greet:putlog "#$handle# greetstatus $chan"
putdcc $idx "I am GreetWondeR.tcl, running Version $greet(version)."
if {![file exists $greet(dir)/$greet(nicks)]} {
  set nsize 0
  } else {
  set nsize [file size $greet(dir)/$greet(nicks)]
  }
set greethow [greet:load greethow([stl $chan])]
putdcc $idx " "
putdcc $idx "FILE SETTINGS:"
putdcc $idx "  Data is saved in $greet(dir)/$greet(data) ([file size $greet(dir)/$greet(data)] bytes)"
putdcc $idx "  Greetnicks are saved in $greet(dir)/$greet(nicks) ($nsize bytes)"
putdcc $idx " "
putdcc $idx "GLOBAL SETTINGS:"
putdcc $idx "  Greeting $a users via $greethow ($greet(max) lines allowed for greets)."
putdcc $idx " "
putdcc $idx "FLOOD SETTINGS:"
putdcc $idx "  Shutdown for $greet(noresponse) mins on flood-join attack"
foreach chanz [channels] {
  if {![info exists cl]} {
    set cl [string length $chanz]
    } {
    set cl2 [string length $chanz]
    if {$cl2 > $cl} { set cl $cl2 }
    }
  }
putdcc $idx "    [format "%-${cl}s   %5s   %1s" Channel Joins Secs]"
foreach chanz [channels] {
  set joins "[lindex [split [lindex [channel info $chanz] 9] :] 0]"
  set secs "[lindex [split [lindex [channel info $chanz] 9] :] 1]"
  if {$joins == 0 || $secs == 0} { 
    if {![info exists nfchan]} { set nfchan $chanz } { append nfchan ", $chanz" }
    } {
    putdcc $idx "    [format "%-${cl}s   %-5s   %1s" $chanz $joins $secs]"
    }
  if {[info exists greetflood($chanz)]} {
    if {$greetflood($chanz) == 1} {
      putdcc $idx "    WARNING: greets on $chanz are currently disabled because of a flood attack."
      }
    }
  }
if {[info exists nfchan]} {
  putdcc $idx " "
  putdcc $idx "  Channels with no flood-join settings:"
  putdcc $idx "    $nfchan"
  putdcc $idx "    (use: .chanset <channel> flood-chan <joins>:<secs>)"
  }
set count 0
putdcc $idx " "
putdcc $idx "GREETS:"
if {![file exists $greet(dir)/$greet(nicks)]} {
  putdcc $idx "  Nick-greets: There are currently no nick-greets saved."
  } else {
  set file [open $greet(dir)/$greet(nicks) r]
  while {![eof $file]} {
    set line [gets $file]
    if {[llength $line] > 1} {
      incr count
      }
    }
  close $file
  if {$count == 1} {
    putdcc $idx "  Nick-greets: There is currently 1 nick-greet saved."
    } {
    putdcc $idx "  Nick-greets: There are currently $count nick-greets saved."
    }
  }
putdcc $idx " "
putdcc $idx "  Chan-greets ($chan):"
set chan [stl $chan]
set greetload "$greet(dir)/channels/[stl [string trimleft $chan #]].dat"
if {![file exists $greetload]} {
    set file [open $greetload w]
    close $file
    }
set count 0
set file [open $greetload r]
while {![eof $file]} {
  set line [gets $file]
  if {[llength $line] > 1} {
    incr count
    }
  }
close $file
set greetall [greet:load greetall([stl $chan])]
if {[greet:load greet($chan)] == 0} { 
  set b "disabled" 
  } else { 
  set b "enabled"
  } 
if {$greetall == 1} { 
  set c "all"
  } elseif {$greetall == 2} {
  set c "known"
  } elseif {$greetall == 0} {
  set c "unkown"
  } {
  greet:debug $handle $idx greetstatus $chan
  return 0
  }
if {[greet:load greet($chan)] == 0} {
  putdcc $idx "    Greets are currently DISABLED!"
  }
if {$count == 0} {
  putdcc $idx "    There are currently no greetlines saved."
  } {
  putdcc $idx "    There are currently $count greetlines saved."
  putdcc $idx "    (use: .greetview $chan)"
  }
}

bind dcc m +greetnick dcc:+greetnick
proc dcc:+greetnick { handle idx arg } {
global greet nickgreets
if {[llength $arg] < 3} {
  putdcc $idx "Usage: .+greetnick <handle> <msg/notice/pub/act> <text>"
  return 0
  }
set nick [lindex $arg 0]
set how [stl [lindex $arg 1]]
if {$how == "msg"} { 
  set how "PRIVMSG"
  } {
if {$how == "notice"} {
   set how "NOTICE"
  } {
if {$how == "pub"} {
  set how "PUBLIC"
  } {
if {$how == "act"} {
  set how "ACTION"
  } {
      putdcc $idx "ERROR: Don't know, how to greet via $how. Only msg, notice, msg or pub is allowed."
      return 0
      }
    }
  }
}
set text [greet:lend 2 $arg]
if {![validuser $nick]} {
  putdcc $idx "I don`t know $nick. Only nicks, which are in the userlist, are allowed!"
  return 0
  }  
if {$text == ""} {
  putdcc $idx "Usage: .+greetnick <handle> <msg/notice/pub/act> <text>"
  return 0
  }
if {![file exists $greet(dir)/$greet(nicks)]} {
  set file [open $greet(dir)/$greet(nicks) w]
  puts $file "$nick $how $text"
  close $file
  } else {
  set fileindex [greet:getfile $greet(dir)/$greet(nicks)]
  foreach line $fileindex {  
    if {[llength $line] > 1} {
      if {[string match "$nick" [lindex $line 0]]} {
        putdcc $idx "Already a greetline for $nick: [greet:lend 2 $line] ([lindex $line 1])"
	return 0
	}
      }
    }
  set file [open $greet(dir)/$greet(nicks) a+]
  puts $file "$nick $how $text"
  close $file
  }
set nickgreets [greet:getfile $greet(dir)/$greet(nicks)]
putdcc $idx "Now greeting $nick with \"$text\" via $how."
return 0
}

bind dcc m -greetnick dcc:-greetnick
proc dcc:-greetnick { handle idx arg } {
global greet nickgreets
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .-greetnick <nick>"
  return 0
  }
set nick [lindex $arg 0]
if {![validuser $nick]} {
  putdcc $idx "I don`t know $nick. Only nicks, which are in the userlist, are allowed."
  return 0
  }
if {![file exists $greet(dir)/$greet(nicks)]} {
  putdcc $idx "No nick greets are saved."
  return 0
  }
greet:putlog "#$handle# -greetnick $arg"
set tmp [greet:getfile $greet(dir)/$greet(nicks)]
set file [open $greet(dir)/$greet(nicks) w]
foreach line $tmp {
  if {$line != ""} {
    if {![string match "$nick *" $line]} {
      puts $file $line
      }
    }
  }
close $file
set nickgreets [greet:getfile $greet(dir)/$greet(nicks)]
putdcc $idx "Deleted greet for $nick."
return 0
}

bind dcc m|n greethelp dcc:greethelp
proc dcc:greethelp { handle idx arg } {
global greet
set arg "[stl $arg]"
if {[string match ".*" $arg]} { set arg [string trimleft $arg .] }
greet:putlog "#$handle# greethelp $arg"
if {$arg == "greetreset"} {
  putdcc $idx "### greetreset"
  putdcc $idx "    Removes _all_ files, created by GreetWondeR and then"
  putdcc $idx "    restartes the script..."
  putdcc $idx "    WARNING: All greets will be lost after a .greetreset!"
  return 0
  }
if {$arg == "+greetnick"} {
  putdcc $idx "### +greetnick <handle> <msg/notice/pub> <text>"
  putdcc $idx "   Adds a greet (<text>) for <nick>."
  putdcc $idx "   Only known nicks (userlist) are allowed."
  putdcc $idx "   NOTE: Only 1 line is allowed."
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .+greetnick Wingman msg Hi Wing, what's up?"
  return 0
  }
if {$arg == "-greetnick"} {
  putdcc $idx "### -greetnick <nick>"
  putdcc $idx "   Dels the greet for <nick>."
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .-greetnick Wingman"
  return 0
  }
if {$arg == "greetnickview"} {
  putdcc $idx "### greetnickview"
  putdcc $idx "    Shows a list of nick-greets."
  return 0
  }
if {$arg == "+greet"} {
  putdcc $idx "### +greet \[channel\] \[+flag\] <text>"
  putdcc $idx "   Adds a greetline for \[channel\]."
  putdcc $idx "   greet-nick, greet-chan and greet-botnick are replaced by the"
  putdcc $idx "   proc vars:"
  putdcc $idx "   if Wingman joins #Eggdrop, he will see instead of greet-nick"
  putdcc $idx "   and greet-chan - Wingman and #Eggdrop."
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .+greet Welcome greet-nick to greet-chan!"
  putdcc $idx "   .+greet #eggdrop Welcome greet-nick to greet-chan"
  putdcc $idx "   .+greet +n Welcome, you are a owner of this chan"
  putdcc $idx " "
  putdcc $idx "See also: -greet, greetview"
  return 0
  }
if {$arg == "-greet"} {
  putdcc $idx "### -greet \[channel\] \[+flag\] <text>"
  putdcc $idx "   Deletes a greetline from \[channel\]."
  putdcc $idx "   Tip: .-greet * deletes ALL greets on \[channel\]!" 
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .-greet Welcome greet-nick to greet-chan!"
  putdcc $idx "   .-greet #eggdrop Welcome greet-nick to greet-chan"
  putdcc $idx "   .-greet +n Welcome, you are a owner of this chan"
  putdcc $idx " "
  putdcc $idx "See also: +greet, greetview"
  return 0
  }
if {$arg == "greetview"} {
  putdcc $idx "### greetview \[channel\]"
  putdcc $idx "   Shows the greets for \[channel\]."
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .greetview"
  putdcc $idx "   .greetview #eggdrop"
  putdcc $idx "See also: +greet, -greet"
  return 0
  }
if {$arg == "greet"} {
  putdcc $idx "### greet \[channel\] <on/off>"
  putdcc $idx "   Enables/disables greets for \[channel\]."
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .greet on"
  putdcc $idx "   .greet #eggdrop on"
  putdcc $idx "See also: greetwho, greethow, greetview"
  return 0
  }
if {$arg == "greetwho"} {
  putdcc $idx "### greetwho \[channel\] <all/known/unknown>"
  putdcc $idx "   Show greets to all, only known users or"
  putdcc $idx "   only unknown users?"
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .greetwho all"
  putdcc $idx "   .greetwho #eggdrop all"
  putdcc $idx "See also: greet, greethow, greetview"
  return 0
  }
if {$arg == "greethow"} {
  putdcc $idx "### greethow \[channel\] \[+flag\] <notice/privmsg>"
  putdcc $idx "   Should i greet users by NOTICE or PRIVMSG (MSG)?"
  putdcc $idx " "
  putdcc $idx "   Example:"
  putdcc $idx "   .greethow notice"
  putdcc $idx "   .greethow #eggdrop notice"
  putdcc $idx "See also: greet, greetwho, greetview"
  return 0
  }
if {$arg == "gmotd"} { 
  putdcc $idx "### gmotd <on/off>"
  putdcc $idx "   Turns on/off the startupmsg \"This Bot is using...\""
  return 0
  }
if {$arg == "guide"} {
  putdcc $idx "A short guide for GreetWondeR $greet(version) (c) Wingman 1999"
  putdcc $idx " "
  putdcc $idx "1. If you want to add a greet for #test, which should get all users:"
  putdcc $idx "   .+greet #test Hi greet-nick - Welcome to greet-chan!"
  putdcc $idx "   .greetwho #test all"
  putdcc $idx " "
  putdcc $idx "2. If you want flag specific greets, try:"
  putdcc $idx "   .+greet #test +n Hi greet-nick - You are an Owner on greet-chan!"
  putdcc $idx " "
  putdcc $idx "3. If you want to greet a nick with a specific line, then use:"
  putdcc $idx "   .+greetnick Nickname pub Hi Nick, what's up?"
  putdcc $idx "   (Only nicknames, which are in the userlist are allowed)"
  putdcc $idx " "
  putdcc $idx "4. A feature of this tcl is its varreplacing:"
  putdcc $idx "   greet-nick, greet-chan and greet-botnick are replaced by the tcl vars,"
  putdcc $idx "   which means, if let's say Wingman joins #Eggdrop and the Botnick"
  putdcc $idx "   is Eggie, he will see (if there's greet like:"
  putdcc $idx "   Hi greet-nick! Welcome to greet-chan - For a help try /msg greet-botnick help"
  putdcc $idx "   Hi Wingman! Welcome to #Eggdrop - For a help try /msg Eggie help"
  putdcc $idx " "
  putdcc $idx "HINT: You can add up to $greet(max) lines for a greet, but just 1 line for a nickgreet."
  return 0
  }
if {$arg == "+greetfile"} {
  putdcc $idx "### .+greetfile \[channel\] \[+flag\] <filename>"
  putdcc $idx "   Adds greets from a file."
  putdcc $idx "   WARNING: There's no line limitation, that's why it's only"
  putdcc $idx "   for global owners."
  return 0
  }
putdcc $idx "Help for TCL: GreetWondeR $greet(version) (c) Wingman 1999"
putdcc $idx " "
putdcc $idx "If you want to add or del greets, use:"
putdcc $idx "  .+/-greet \[channel\] \[+flag\] <text>"
putdcc $idx "  .+greetnick <nick> <msg/notice/pub/act> <text>"
putdcc $idx "  .-greetnick <nick>"
putdcc $idx "  .+greetfile \[channel\] \[+flag\] <filename>"
putdcc $idx " "
putdcc $idx "If you want to see the greets, use:"
putdcc $idx "  .greetview \[channel\]                        .greetnickview"
putdcc $idx " "
putdcc $idx "If you want to change the settings for greets, use:"
putdcc $idx "  .greethow \[channel\] \[+flag\] <notice/privmsg>"
putdcc $idx "  .greetwho \[channel\] <all/known/unknown>"
putdcc $idx "  .greet \[channel\] <on/off>"
putdcc $idx " "
putdcc $idx "Other Commands:"
putdcc $idx "  .greetreset                                 .gmotd <on/off>"
putdcc $idx "  .greetstatus \[channel\]"
putdcc $idx " "
putdcc $idx "If you want a short guide to GreetWondeR.tcl, use '.greethelp guide'"
putdcc $idx " "
putdcc $idx "Words in \[ \] are options and not neccessary."
putdcc $idx " "
putdcc $idx "You can get help on individual commands: '.greethelp <command>'"
return 0
}

bind dcc m greetnickview dcc:greetnickview
proc dcc:greetnickview { handle idx arg } {
global greet nickgreets
greet:putlog "#$handle# greetnickview"
if {![file exists $greet(dir)/$greet(nicks)]} {
  putdcc $idx "No nick greets saved."
  return 0
  }
set file [open $greet(dir)/$greet(nicks) r]
while {![eof $file]} {
  set line [gets $file]
  if {[llength $line] > 1} {
    set nick [lindex $line 0]
    set how [lindex $line 1]
    set text [greet:lend 2 $line]
    lappend tmp "  $nick ($how): $text"
    }
  }
if {![info exists tmp]} {
  putdcc $idx "No nick greets saved."
  return 0
  } {
  putdcc $idx "Showing nick greets:"
  set nickgreets $tmp
  foreach line $tmp {
    putdcc $idx " $line"
    }
  }  
}
 
bind dcc m greet dcc:greet
proc dcc:greet { handle idx arg } {
global greet
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greet \[channel\] <on/off>"
  return 0
  }
set greetchan ""
set greetwhat ""
set greetflags ""
if {[string match "#*" $arg]} {
    set greetchan [stl [lindex $arg 0]]
    set greetwhat [greet:lend 1 $arg]
    if {![validchan $greetchan]} {
      putdcc $idx "ERROR: I'm not on $greetchan"
      return 0
      }
    } else {
    set greetwhat [stl $arg]
    set greetchan [stl [lindex [console $idx] 0]]
    }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
greet:putlog "#$handle# greet ($greetchan) $greetwhat"
if {$greetwhat == "on"} {
  greet:save greet($greetchan) 1
  putdcc $idx "Greets for $greetchan are now enabled."
  return 0
  }
if {$greetwhat == "off"} {
  greet:save greet($greetchan) 0
  putdcc $idx "Greets for $greetchan are now disabled."
  return 0
  }
putdcc $idx "Usage: .greet \[channel\] <on/off>"
}

bind dcc m|n greethow dcc:greethow
proc dcc:greethow { handle idx arg } {
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greethow \[channel\] \[+flag\] <notice/msg>"
  return 0
  }
if {[llength $arg] == 1} {
  set greetwhat [stl $arg]
  } {
  if {[string match "#*" $arg]} {
    set greetchan [lindex $arg 0]
    set greetwhat [lindex $arg 1]
    if {![validchan $greetchan]} {
      putdcc $idx "I'm not on $greetchan."
      return 0
      }
    if {[string match "+*" [lindex $arg 1]]} {
      if {[string length [lindex $arg 1]] != 2} {
          putdcc $idx "Only 1 flag is allowed."
          return 0
          } {
        set greetflag [string trimleft [lindex $arg 1] +]
	set greetwhat [lindex $arg 2]
	}
      }
    } {
      if {[string match "+*" $arg]} {
        if {[string length [lindex $arg 0]] != 2} {
          putdcc $idx "Only 1 flag is allowed."
          return 0
          } {
          set greetflag [string trimleft [lindex $arg 0] +]
          set greetwhat [lindex $arg 1]
          set greetchan [stl [lindex [console $idx] 0]]
          if {$greetchan == "*"} {
            putdcc $idx "Your console channel is invalid."
            return 0
	    }
	  }
	}
    }  
  if {[info exists greetchan]} {
    if {[info exists greetflag]} {
      if {$greetwhat == "notice"} {
	greet:save greethow($greetflag)([stl $greetchan]) NOTICE 
        putdcc $idx "Now greeting +$greetflag users on $greetchan via NOTICE."
        return 0
        }
      if {$greetwhat == "privmsg" || $greetwhat == "msg"} {
	greet:save greethow($greetflag)([stl $greetchan]) PRIVMSG 
        putdcc $idx "Now greeting +$greetflag users on $greetchan via PRIVMSG."
        return 0
        }
      }
    if {$greetwhat == "notice"} {
      greet:save greethow([stl $greetchan]) NOTICE
      putdcc $idx "Now greeting users on $greetchan via NOTICE."
      return 0
      }
    if {$greetwhat == "privmsg" || $greetwhat == "msg"} {
      greet:save greethow([stl $greetchan]) PRIVMSG
      putdcc $idx "Now greeting users on $greetchan via PRIVMSG"
      return 0
      }
    } 
  }
putdcc $idx "Usage: .greethow \[channel\] \[+flag\] <NOTICE/PRIVMSG>"
}

bind dcc m|n greetwho dcc:greetwho
proc dcc:greetwho { handle idx arg } {
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .greetwho \[channel\] <all/known/unkown>"
  return 0
  }
if {[string match "#*" $arg]} {
    set greetwhat [stl [greet:lend 1 $arg]]
    set greetchan [stl [lindex $arg 0]]
    if {![validchan $greetchan]} {
      putdcc $idx "ERROR: I'm not on $greetchan"
      return 0
      }
    } else {
    set greetwhat [lindex [stl $arg] o]
    set greetchan [stl [lindex [console $idx] 0]]
    if {$greetchan == "*"} {
      putdcc $idx "Your console channel is invalid."
      return 0
      }
    }
if {![matchattr $handle n]} {
  if {![matchchanattr $handle |n $greetchan]} {
    putdcc $idx "Sorry, you're not chanowner on $greetchan"
    return 0
    }
  }
greet:putlog "#$handle# greetwho ($greetchan) $greetwhat"
if {$greetwhat == "all"} {
  greet:save greetall($greetchan) 1
  putdcc $idx "Now showing greets on $greetchan to all users"
  return 0
  }
if {$greetwhat == "known"} {
  greet:save greetall($greetchan) 0
  putdcc $idx "Now showing greets on $greetchan to only known users"
  return 0
  }  
if {$greetwhat == "unknown"} {
  greet:save greetall($greetchan) 2
  putdcc $idx "Now showing greets on $greetchan to only unknown users"
  return 0
  }
putdcc $idx "Usage: .greetwho \[channel\] <all/known/unknown>"
}

bind dcc m|n greetview dcc:greetview
proc dcc:greetview { handle idx arg } {
global greet changreets
if {[llength $arg] < 1} {
  set chan [stl [lindex [console $idx] 0]]
  if {$chan == "*"} {
    putdcc $idx "Your console channel is invalid."
    return 0
    } 
  } else {
  set chan [stl [lindex $arg 0]]
  }
if {![validchan $chan]} {
  putdcc $idx "ERROR: I'm not on $chan"
  return 0
  }
greet:putlog "#$handle# ($chan) greetview"
set greetload "$greet(dir)/channels/[stl [string trimleft $chan #]].dat"
set greetchan [greet:load greet([stl $chan])]
set greetallchan [greet:load greetall([stl $chan])]
set greethowchan [greet:load greethow([stl $chan])]
if {$greetallchan == ""} {
  set greetallchan $greet(all)
  greet:save greetall([stl $chan]) $greet(all)
  } 
if {$greetallchan == 0} {
  set c "all"
  } elseif { $greetallchan == 1} {
  set c "only known"
  } elseif {$greetallchan == 2} {
  set c "only unkown"
  }
putdcc $idx "DISPLAYING GREETS FOR [string toupper $chan]:"
if {[greet:load greet([stl $chan])] == 0} {
  putdcc $idx " "
  putdcc $idx "Greets are currently DISABLED!"
  putdcc $idx "(use: greet $chan on to enable)"
  }
if {![file exists $greetload]} {
    set file [open $greetload w]
    close $file
    return 0
    }
set greetstore ""
set file [open $greetload r]
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    lappend greetstore $line
    }
  }
close $file
set greeta ""
set greetb ""
foreach line $greetstore {
  if {[string match "+*" $line]} {
    lappend greetflag([lindex $line 0]) "[greet:lend 1 $line]"
    if {[lsearch -exact $greeta [lindex $line 0]] == -1} {
      append greeta "[lindex $line 0] "
      }
    } else {
    lappend greetb $line
    }
  }
set tmp 0
if {$greeta != ""} {
  set tmp 1
  foreach flag $greeta {
    set greethow($flag) [greet:load greethow([string trimleft $flag +])([stl $chan])]
    if {$greethow($flag) != ""} {
      set greethw $greethow($flag)
      } {
      set greethw $greethowchan
      }
    putdcc $idx " "
    putdcc $idx "Greets for $flag users via $greethw:"
    foreach line $greetflag($flag) {
      putdcc $idx "  $line"
      }
    }
  }
if {$greetb != ""} {
  set tmp 1
  putdcc $idx " "
  putdcc $idx "Greets for $c users via $greethowchan:"
  foreach line $greetb {
    putdcc $idx "  $line"
    }
  }
if {$tmp == 0} {
  putdcc $idx " "
  putdcc $idx "There are currently no greets saved for $chan."
  putdcc $idx "(use .+greet $chan \[+flag\] <greet>)"
  }
set changreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft $chan #].dat]
}

bind dcc n +greetfile dcc:+greetfile
proc dcc:+greetfile { handle idx arg } {
global greet changreets
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .+greetfile \[channel\] \[+flag\] <filename>"
  return 0
  }
if {[llength $arg] < 2} {
  if {[string match "#*" $arg]} {
    putdcc $idx "Usage: .+greetfile \[channel\] \[+flag\] <filename>"
    return 0
    }
  }
set greetflags ""
if {[string match "#*" $arg]} {
  if {[string match "+*" [lindex $arg 1]]} {
    set greethow [greet:lend 2 $arg]
    set greetflags [lindex $arg 1]
    set greetchan [lindex $arg 0]
    } else {
    set greethow [greet:lend 1 $arg]
    set greetchan [lindex $arg 0]
    }
  if {![validchan $greetchan]} {
    putdcc $idx "ERROR: I'm not on $greetchan"
    return 0
    }
  } else {
  if {[string match "+*" [lindex $arg 0]]} {
    set greethow [greet:lend 1 $arg]
    set greetflags [lindex $arg 0]
    set greetchan [lindex [console $idx] 0]
    } else {
    set greethow $arg
    set greetchan [lindex [console $idx] 0]
    }
  }
if {![matchattr $handle n]} {
  if {![matchchanattr $handle |n $greet(chan)]} {
    putdcc $idx "Sorry, you're not chanowner on $greetchan"
    return 0
    }
  }
if {[string length $greetflags] > 2} {
  putdcc $idx "ERROR: only 1 flag is allowed, e.g. +greet +n <filename>"
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {$greethow == ""} {
  putdcc $idx "Usage:  .+greetfile \[channel\] \[+flag\] <filename>"
  return 0
  }
if {![file exists $greethow]} {
  putdcc $idx "ERROR: can't find file: $greethow"
  return 0
  }
if {$greetflags != ""} {
  set validflags "a b c d e f g h i j k l m n o p q r s t u v w x y z 1 2 3 4 5 6 7 8 9 0"
  if {[lsearch -exact $validflags [stl [string trimleft $greetflags +]]] == -1} {
    putdcc $idx "ERROR: $greetflags is no valid flag."
    return 0
    }
  greet:putlog "#$handle# +greetfile ($greetchan) ($greetflags) $greethow"
  } else {
  greet:putlog "#$handle# +greetfile ($greetchan) $greethow"
  }
set greetsave "$greet(dir)/channels/[stl [string trimleft $greetchan #]].dat"
set greetfile [greet:getfile $greethow]
set file [open $greetsave a+]
set count 0
if {$greetflags != ""} {
  foreach line $greetfile {
    if {$line != ""} {
      puts $file "$greetflags $line"
      putdcc $idx "  Adding: $line"
      incr count
      }
    }
  } {
  foreach line $greetfile {
    if {$line != ""} {
      puts $file $line
      putdcc $idx "  Adding: $line"
      incr count
      }
    }
  }  
close $file
set changreets([stl $greetchan]) ""
set file [open $greetsave r]
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    lappend changreets([stl $greetchan]) $line
    }
  }
close $file
if {$greetflags != ""} {
  putdcc $idx "Added $count lines for greets on $greetchan."
  } {
  putdcc $idx "Added $count lines for $greetflags users on $greetchan."
  }
}

bind dcc m|n +greet dcc:+greet
proc dcc:+greet { handle idx arg } {
global greet changreets
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .+greet \[channel\] \[+flag\] <greet>"
  return 0
  }
if {[llength $arg] < 2} {
  if {[string match "#*" $arg]} {
    putdcc $idx "Usage: .+greet \[channel\] \[+flag\] <greet>"
    return 0
    }
  }
set greetflags ""
if {[string match "#*" $arg]} {
  if {[string match "+*" [lindex $arg 1]]} {
    set greethow [greet:lend 2 $arg]
    set greetflags [lindex $arg 1]
    set greetchan [lindex $arg 0]
    } else {
    set greethow [greet:lend 1 $arg]
    set greetchan [lindex $arg 0]
    }
  if {![validchan $greetchan]} {
    putdcc $idx "ERROR: I'm not on $greetchan"
    return 0
    }
  } else {
  if {[string match "+*" [lindex $arg 0]]} {  
    set greethow [greet:lend 1 $arg]
    set greetflags [lindex $arg 0]
    set greetchan [lindex [console $idx] 0]
    } else {
    set greethow $arg
    set greetchan [lindex [console $idx] 0]
    }
  }
if {![matchattr $handle n]} {
  if {![matchchanattr $handle |n $greet(chan)]} {
    putdcc $idx "Sorry, you're not chanowner on $greetchan"
    return 0
    }
  }
if {[string length $greetflags] > 2} {
  putdcc $idx "ERROR: only 1 flag is allowed, e.g. +greet +n <greet>"
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {$greethow == ""} {
  putdcc $idx "Usage:  .+greet \[channel\] \[+flag\] <greet>"
  return 0
  }
if {$greetflags != ""} {
  set validflags "a b c d e f g h i j k l m n o p q r s t u v w x y z 1 2 3 4 5
6 7 8 9 0"
  if {[lsearch -exact $validflags [stl [string trimleft $greetflags +]]] == -1} {
    putdcc $idx "ERROR: $greetflags is no valid flag."
    return 0
    }
  greet:putlog "#$handle# +greet ($greetchan) ($greetflags) $greethow"
  } else {
  greet:putlog "#$handle# +greet ($greetchan) $greethow"
  }
set greetsave "$greet(dir)/channels/[stl [string trimleft $greetchan #]].dat"
set count 0
if {[file exists $greetsave]} {
  set file [open $greetsave r]
  while {![eof $file]} {
    set line [gets $file]
    if {$line != ""} {
      if {$greetflags != ""} {
        if {[string match "$greetflags *" $line]} {
          incr count
          }
        } else {
	if {![string match "+*" $line]} {
          incr count
	  }
        }
      }
    }
  close $file
  } else {
  set file [open $greetsave w]
  if {$greetflags == ""} {
    puts $file $greethow
    } else {
    puts $file "$greetflags $greethow"
    }
  close $file
  }
if {$count >= $greet(max)} {
  putdcc $idx "ERROR: Only $greet(max) lines are allowed for greets."
  return 0
  }
set file [open $greetsave a+]
if {$greetflags == ""} {
  puts $file $greethow
  } else {
  puts $file "$greetflags $greethow"
  }
close $file
if {$greetflags != ""} {
  putdcc $idx "Added $greethow ($greetflags users) for $greetchan"
  } else {
  putdcc $idx "Added $greethow for $greetchan"
  }
set changreets([stl $greetchan]) ""
set file [open $greetsave r]
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    lappend changreets([stl $greetchan]) $line
    }
  }
close $file
}

bind bot - sg_update bot:sg_update 
proc bot:sg_update { bot com newver } {
set notetxt "GreetWondeR.tcl: Update to $newver is available at http://defiant.vilstal.net/~wingman/"
foreach user [userlist n] {
  if {[notes $user] < 10} {
    sendnote "Wingman@$bot" $user $notetxt
    }
  }
}

bind bot - sg_info bot:sginfo
proc bot:sginfo { bot com arg } {
global greet
putbot $bot "sg_version $greet(version) - public"
}

bind dcc m|n -greet dcc:-greet
proc dcc:-greet { handle idx arg } {
global greet changreets
if {[llength $arg] < 1} {
  putdcc $idx "Usage: .-greet \[channel\] \[+flag\] <greet>"
  return 0
  }
if {[llength $arg] < 2} {
  if {[string match "#*" $arg]} {
    putdcc $idx "Usage: .-greet \[channel\] \[+flag\] <greet>"
    return 0
    }
  }
set greetflags ""
if {[string match "#*" $arg]} {
  if {[string match "+*" [lindex $arg 1]]} {
    set greethow [greet:lend 2 $arg]
    set greetflags [lindex $arg 1]
    set greetchan [lindex $arg 0]
    } else {
    set greethow [greet:lend 2 $arg]
    set greetchan [lindex $arg 0]
    }
  if {![validchan $greetchan]} {
    putdcc $idx "ERROR: I'm not on $greetchan"
    return 0
    }
  } else {
  if {[string match "+*" [lindex $arg 0]]} {
    set greethow [greet:lend 1 $arg]
    set greetflags [lindex $arg 0]
    set greetchan [lindex [console $idx] 0]
    } else {
    set greethow $arg
    set greetchan [lindex [console $idx] 0]
    }
  }
if {![matchattr $handle n]} {
  if {![matchchanattr $handle |n $greet(chan)]} {
    putdcc $idx "Sorry, you're not chanowner on $greetchan"
    return 0
    }
  }
if {[string length $greetflags] > 2} {
  putdcc $idx "ERROR: only 1 flag is allowed, e.g. -greet +n <greet>"
  return 0
  }
if {$greetchan == "*"} {
  putdcc $idx "Your console channel is invalid."
  return 0
  }
if {$greetflags != ""} {
  set validflags "a b c d e f g h i j k l m n o p q r s t u v w x y z 1 2 3 4 5
6 7 8 9 0"
  if {[lsearch -exact $validflags [stl [string trimleft $greetflags +]]] == -1} {
    putdcc $idx "ERROR: $greetflags is no valid flag."
    return 0
    }
  greet:putlog "#$handle# -greet ($greetchan) ($greetflags) $greethow"
  } else {
  greet:putlog "#$handle# -greet ($greetchan) $greethow"
  }
set greetnew ""
set greetfound 0
set greetsave "$greet(dir)/channels/[stl [string trimleft $greetchan #]].dat"
if {![file exists $greetsave]} { 
  putdcc $idx "ERROR: No greets saved for $greetchan"
  return 0
  }
if {$greetflags == ""} {
  if {$greethow == "*"} {
    set file [open $greetsave w]
    close $file
    putdcc $idx "Deleted ALL greets on $greetchan"
    set changreets([stl $greetchan]) ""
    return 0
    }
  }
set file [open $greetsave r] 
while {![eof $file]} {
  set line [gets $file]
  if {$line != ""} {
    if {$greetflags != ""} {
      if {"$greetflags $greethow" == $line} {
        set greetfound 1
        } else { 
        lappend greetnew $line
        }
      } else { 
    if {[string match "$greethow*" $line]} {
      set greetfound 1
      } else {
      lappend greetnew $line
      }
    }
  }
}
close $file
if {$greetfound == 0} {
  putdcc $idx "Can't find $greethow for $greetchan"
  return 0
  }
if {[llength $greetnew] < 1} {
  set file [open $greetsave w]
  close $file
  putdcc $idx "Deleted greets for $greetchan" 
  set changreets([stl $greetchan]) "" 
  return 0
  }
set file [open $greetsave w]
foreach line $greetnew {
  puts $file $line
  }
close $file
set changreets([stl $greetchan]) ""
set file [open $greetsave r]
while {![eof $file]} {
  set line [gets $file]
  if {[llength $line] > 1} {
    lappend changreets([stl $greetchan]) $line
    }
  }
close $file
putdcc $idx "Deleted $greethow for $greetchan"
}

proc greet:replace { nick chan line } {
global botnick
if {[string match "*greet-nick*" $line]} {
  regsub -all greet-nick $line $nick line
  }
if {[string match "*greet-chan*" $line]} {
  regsub -all greet-chan $line $chan line
  }
if {[string match "*greet-botnick*" $line]} {
  regsub -all greet-botnick $line $botnick line
  }
return $line
}

proc greet:queue { chan } {
global que greet
if {$greet(delay) == 0} { return 0 }
if {![info exists que($chan)]} {
  set que($chan) 1
  utimer $greet(delay) "greet:unset $chan"
  return 0
  } { return 1 }
}

proc greet:unset { chan } {
global que
if {[info exists que($chan)]} { unset que($chan) }
}

bind join - *!*@* greet:join
proc greet:join { nick uhost handle chan } {
global gqu greet botnick nickgreets changreets greetflood 
if {![info exists nickgreets]} { set nickgreets [greet:getfile $greet(dir)/$greet(nicks)] } 
if {![info exists changreets([stl $chan])]} { set changreets([stl $chan]) [greet:getfile $greet(dir)/channels/[string trimleft [stl $chan] #].dat] }
if {[info exists greetflood($chan)]} { if {$greetflood($chan) == 1} { return 0 }
}
if {$nick == $botnick && [matchattr $handle b]} { return 0 }
set greetchan [greet:load greet($chan)]
if {$greetchan == 0} { return 0 }
if {$handle != "*"} {
  if {$nickgreets != ""} {
    foreach line $nickgreets {    
      if {[string match "$handle *" $line]} {
        set how [lindex $line 1]
        set text [greet:replace $nick $chan [greet:lend 2 $line]]
        if {$how == "PUBLIC"} {
	  if {[greet:queue [stl $chan]]} { return 0 } 
	  putchan $chan "$text"
          return 0
          }
        if {$how == "NOTICE"} {
	  if {[greet:queue [stl $chan]]} { return 0 }
	  puthelp "NOTICE $nick :$text"
          return 0
          }
	if {$how == "PRIVMSG"} {
	  if {[greet:queue [stl $chan]]} { return 0 }
	  puthelp "PRIVMSG $nick :$text"
	  return 0
	  }
	if {$how == "ACTION"} {
	  if {[greet:queue [stl $chan]]} { return 0 }
	  puthelp "PRIVMSG $chan :\001ACTION $text\001"
	  return 0
	  }
        }
      }
    }
  }
if {![info exists changreets([stl $chan])]} { return 0 }
if {$changreets([stl $chan]) == ""} { return 0 } 
set greethow [greet:load greethow([stl $chan])]
set greetstore ""
foreach line $changreets([stl $chan]) { lappend greetstore $line }
set greeta ""
set greetb ""
foreach line $greetstore {
  if {[string match "+*" $line]} {
    lappend greetflag([lindex $line 0]) [greet:lend 1 $line]
    if {[lsearch -exact $greeta [lindex $line 0]] == -1} { append greeta "[lindex $line 0] " }
    } { lappend greetb $line }
  }
if {$greeta != ""} {
  foreach flag $greeta {
    if {[matchattr $handle $flag] || [matchchanattr $handle |$flag $chan]} {
      set greethw($flag) [greet:load greethow($flag)([stl $chan])]
      if {$greethw($flag) != ""} { set greethow $greethw($flag) }
      if {[greet:queue [stl $chan]]} { return 0 }
      foreach line $greetflag($flag) {
	puthelp "$greethow $nick :[greet:replace $nick $chan $line]"
        }
      return 0
      }
    }
  }  
set greetallchan [greet:load greetall([stl $chan])]
if {$greetallchan == 0} { if {$handle == "*"} { return 0 } }
if {$greetallchan == 2} { if {$handle != "*"} { return 0 } }
if {$greetb != ""} {
  if {[greet:queue [stl $chan]]} { return 0 }
  foreach line $greetb { 
    puthelp "$greethow $nick :[greet:replace $nick $chan $line]"
    }
  return 0
  }
}

greet:init start - 
